Index: code/branches/dockingsystem2/src/modules/docking/Dock.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/Dock.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/Dock.cc	(revision 8501)
@@ -278,2 +278,3 @@
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockToShip.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockToShip.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockToShip.cc	(revision 8501)
@@ -58,9 +58,9 @@
     }
 
-    void DockToShip::setTargetId(std::string str) {
+    void DockToShip::setTargetId(const std::string& str) {
         this->target = str;
     }
 
-    std::string DockToShip::getTargetId() {
+    const std::string& DockToShip::getTargetId() const {
         return this->target;
     }
@@ -99,2 +99,3 @@
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockToShip.h
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockToShip.h	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockToShip.h	(revision 8501)
@@ -61,6 +61,6 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void setTargetId(std::string str);
-            std::string getTargetId();
+            void setTargetId(const std::string& str);
+            const std::string& getTargetId() const;
 
             virtual bool docking(PlayerInfo* player); //!< Called when docking starts
Index: code/branches/dockingsystem2/src/modules/docking/DockingAnimation.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingAnimation.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingAnimation.cc	(revision 8501)
@@ -67,2 +67,3 @@
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockingController.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingController.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingController.cc	(revision 8501)
@@ -29,6 +29,7 @@
 #include "DockingController.h"
 
+#include "infos/PlayerInfo.h"
+#include "worldentities/ControllableEntity.h"
 #include "Dock.h"
-
 
 namespace orxonox
@@ -56,4 +57,6 @@
     {
         // TODO; Give control back to player
+        PlayerInfo* player = this->entity->getPlayer();
+        assert(player);
 
         if (docking)
@@ -63,2 +66,3 @@
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockingEffect.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingEffect.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingEffect.cc	(revision 8501)
@@ -71,2 +71,3 @@
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockingPrereqs.h
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingPrereqs.h	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingPrereqs.h	(revision 8501)
@@ -67,4 +67,5 @@
     class Dock;
     class DockingAnimation;
+    class DockingController;
     class DockingTarget;
     class DockingEffect;
Index: code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc	(revision 8501)
@@ -59,10 +59,11 @@
 
 
-    void DockingTarget::setName(std::string str) {
+    void DockingTarget::setName(const std::string& str) {
         this->name = str;
     }
 
-    std::string DockingTarget::getName() {
+    const std::string& DockingTarget::getName() const {
         return this->name;
     }
 }
+
Index: code/branches/dockingsystem2/src/modules/docking/DockingTarget.h
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/DockingTarget.h	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/DockingTarget.h	(revision 8501)
@@ -63,6 +63,6 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            virtual void setName(std::string str);
-            virtual std::string getName();
+            virtual void setName(const std::string& str);
+            virtual const std::string& getName() const;
     };
 
Index: code/branches/dockingsystem2/src/modules/docking/MoveToDockingTarget.cc
===================================================================
--- code/branches/dockingsystem2/src/modules/docking/MoveToDockingTarget.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/modules/docking/MoveToDockingTarget.cc	(revision 8501)
@@ -65,2 +65,3 @@
 
 }
+
Index: code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.cc	(revision 8493)
+++ code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.cc	(revision 8501)
@@ -393,10 +393,4 @@
     }
 
-    void ArtificialController::positionReached()
-    {
-        // Override me !
-    }
-
-
     /**
         @brief Unregisters a slave from its master. Initiated by a slave.
Index: code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.h
===================================================================
--- code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.h	(revision 8493)
+++ code/branches/dockingsystem2/src/orxonox/controllers/ArtificialController.h	(revision 8501)
@@ -97,5 +97,5 @@
             void moveToTargetPosition();
 
-            virtual void positionReached();
+            virtual void positionReached() {}
 
             void removeFromFormation();