Index: /code/branches/dockingsystem2/data/levels/docking.oxw
===================================================================
--- /code/branches/dockingsystem2/data/levels/docking.oxw	(revision 8559)
+++ /code/branches/dockingsystem2/data/levels/docking.oxw	(revision 8560)
@@ -1,5 +1,5 @@
 <LevelInfo
  name = "Transporter"
- description = "Level with a Transporter. Demostrates the docking system."
+ description = "Level with a Transporter. Demonstrates the docking system."
  tags = ""
 />
@@ -26,6 +26,4 @@
 
     <Light type="directional" position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-
-
 
     <?lua for i = 1, 10, 1 do ?>
@@ -113,6 +111,6 @@
             </events>
             <attached>
-                <DistanceTrigger position="0,0,0" distance="30" target="Pawn" beaconMode="exclude" targetname="bcnDestroyer" name="dockMe" />
-                <Billboard material="Examples/Flare" colour="1.0, 0, 0" />
+                <DistanceTrigger position="0,0,-200" distance="30" target="Pawn" beaconMode="exclude" targetname="bcnDestroyer" name="dockMe" />
+                <Billboard position="0,0,-200" material="Examples/Flare" colour="1.0, 0, 0" />
             </attached>
         </Dock>
Index: /code/branches/dockingsystem2/src/modules/docking/Dock.cc
===================================================================
--- /code/branches/dockingsystem2/src/modules/docking/Dock.cc	(revision 8559)
+++ /code/branches/dockingsystem2/src/modules/docking/Dock.cc	(revision 8560)
@@ -29,5 +29,5 @@
 /**
     @file Dock.cc
-	@brief Docking system main class
+    @brief Docking system main class
 */
 
@@ -90,5 +90,5 @@
         {
             if(!pTrigger->isForPlayer()) {  // The PlayerTrigger is not exclusively for Pawns which means we cannot extract one.
-                COUT(2) << "Docking:execute PlayerTrigger was not triggered by a player.." << std::endl;
+                COUT(4) << "Docking:execute PlayerTrigger was not triggered by a player.." << std::endl;
                 return false;
             }
@@ -97,10 +97,10 @@
         else
         {
-            COUT(2) << "Docking::execute Not a player trigger, can't extract pawn from it.." << std::endl;
+            COUT(4) << "Docking::execute Not a player trigger, can't extract pawn from it.." << std::endl;
             return false;
         }
         if(pawn == NULL)
         {
-            COUT(2) << "Docking::execute Can't retrieve Pawn from Trigger. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
+            COUT(4) << "Docking::execute Can't retrieve Pawn from Trigger. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
             return false;
         }
@@ -158,5 +158,5 @@
         if(candidates.find(player) == candidates.end())
         {
-            COUT(0) << "Dock::dock Player is not a candidate!" << std::endl;
+            COUT(2) << "Dock::dock Player is not a candidate!" << std::endl;
             return false;
         }
@@ -177,5 +177,5 @@
         if(docked.find(player) == docked.end())
         {
-            COUT(0) << "Dock::dockingAnimationFinished Player is not currently docked." << std::endl;
+            COUT(2) << "Dock::dockingAnimationFinished Player is not currently docked." << std::endl;
             return false;
         }
@@ -190,5 +190,5 @@
         if(docked.find(player) == docked.end())
         {
-            COUT(0) << "Dock::undock Player is not docked to this Dock." << std::endl;
+            COUT(2) << "Dock::undock Player is not docked to this Dock." << std::endl;
             return false;
         }
@@ -208,5 +208,5 @@
 
     bool Dock::undockingAnimationFinished(PlayerInfo* player) {
-        COUT(0) << "Dock::undockingAnimationFinished executed" << std::endl;
+        COUT(4) << "Dock::undockingAnimationFinished executed" << std::endl;
         return true;
     }
Index: /code/branches/dockingsystem2/src/modules/docking/DockToShip.cc
===================================================================
--- /code/branches/dockingsystem2/src/modules/docking/DockToShip.cc	(revision 8559)
+++ /code/branches/dockingsystem2/src/modules/docking/DockToShip.cc	(revision 8560)
@@ -43,5 +43,5 @@
     {
         RegisterObject(DockToShip);
-        COUT(0) << "DockToShip instance created.." << endl;
+        COUT(4) << "DockToShip instance created.." << endl;
     }
 
@@ -69,5 +69,5 @@
     bool DockToShip::docking(PlayerInfo* player)
     {
-        COUT(0) << "DockToShip::attach" << endl;
+        COUT(4) << "DockToShip::attach" << endl;
 
         DockingTarget *target = DockingEffect::findTarget(this->target);
@@ -79,5 +79,5 @@
         ControllableEntity *dockTo = (ControllableEntity*) target->getParent();
         if (dockTo == NULL) {
-            COUT(0) << "Parent is not a ControllableEntity.." << std::endl;
+            COUT(2) << "Parent is not a ControllableEntity.." << std::endl;
             return false;
         }
@@ -92,5 +92,5 @@
     bool DockToShip::release(PlayerInfo* player)
     {
-        COUT(0) << "DockToShip::release" << endl;
+        COUT(4) << "DockToShip::release" << endl;
 
         player->stopTemporaryControl();
Index: /code/branches/dockingsystem2/src/modules/docking/DockingController.cc
===================================================================
--- /code/branches/dockingsystem2/src/modules/docking/DockingController.cc	(revision 8559)
+++ /code/branches/dockingsystem2/src/modules/docking/DockingController.cc	(revision 8560)
@@ -93,5 +93,5 @@
         if (docking)
         {
-            COUT(0) << "DockingController::takeControl Taking over control." << std::endl;
+            COUT(4) << "DockingController::takeControl Taking over control." << std::endl;
 
             entity->setDestroyWhenPlayerLeft(false);
@@ -104,5 +104,5 @@
     void DockingController::positionReached()
     {
-        COUT(0) << "DockingController::positionReached() called." << std::endl;
+        COUT(4) << "DockingController::positionReached() called." << std::endl;
 
         assert(this->player);
@@ -110,7 +110,7 @@
 
         // stop spaceship
-        dock->attach(entity);
+        entity->setPosition(dock->getWorldPosition());
         entity->setVelocity(0, 0, 0);
-        entity->setOrientation(dock->getOrientation());
+        entity->setOrientation(dock->getWorldOrientation());
 
         // give control back to player
Index: /code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc
===================================================================
--- /code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc	(revision 8559)
+++ /code/branches/dockingsystem2/src/modules/docking/DockingTarget.cc	(revision 8560)
@@ -29,5 +29,5 @@
 /**
     @file DockingTarget.cc
-	@brief Docking system main class
+    @brief Docking system main class
 */
 
@@ -55,5 +55,5 @@
         XMLPortParam(DockingTarget, "name", setName, getName, xmlelement, mode);
 
-        COUT(0) << "DockingTarget with name '" << this->getName() << "' created.." << std::endl;
+        COUT(4) << "DockingTarget with name '" << this->getName() << "' created.." << std::endl;
     }
 