Index: /code/branches/presentation/data/gui/scripts/DockingDialog.lua
===================================================================
--- /code/branches/presentation/data/gui/scripts/DockingDialog.lua	(revision 8567)
+++ /code/branches/presentation/data/gui/scripts/DockingDialog.lua	(revision 8568)
@@ -44,4 +44,7 @@
         item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         listbox:addItem(item)
+        if k == 1 then
+            listbox:setItemSelectState(item, true)
+        end
     end
 end
Index: /code/branches/presentation/src/modules/docking/DockToShip.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/DockToShip.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockToShip.cc	(revision 8568)
@@ -59,9 +59,9 @@
 
     void DockToShip::setTargetId(const std::string& str) {
-        this->target = str;
+        this->target_ = str;
     }
 
     const std::string& DockToShip::getTargetId() const {
-        return this->target;
+        return this->target_;
     }
 
@@ -71,7 +71,7 @@
         COUT(4) << "DockToShip::attach" << endl;
 
-        DockingTarget *target = DockingEffect::findTarget(this->target);
+        DockingTarget *target = DockingEffect::findTarget(this->target_);
         if (target == NULL) {
-            COUT(0) << "Can't retrieve target for '" << this->target << "'.." << std::endl;
+            COUT(0) << "Can't retrieve target for '" << this->target_ << "'.." << std::endl;
             return false;
         }
Index: /code/branches/presentation/src/modules/docking/DockToShip.h
===================================================================
--- /code/branches/presentation/src/modules/docking/DockToShip.h	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockToShip.h	(revision 8568)
@@ -67,5 +67,5 @@
             virtual bool release(PlayerInfo* player); //!< Called when player wants undock
         private:
-            std::string target;
+            std::string target_;
     };
 
Index: /code/branches/presentation/src/modules/docking/DockingAnimation.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingAnimation.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingAnimation.cc	(revision 8568)
@@ -41,4 +41,6 @@
     {
         RegisterObject(DockingAnimation);
+
+        this->parent_ = NULL;
     }
 
Index: /code/branches/presentation/src/modules/docking/DockingAnimation.h
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingAnimation.h	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingAnimation.h	(revision 8568)
@@ -73,9 +73,9 @@
             static DockingTarget *findTarget(std::string name); //!< Iterates through all DockingTarget objects to find the one with name=target
 
-            void setParent(Dock *parent) { this->parent = parent; }
+            void setParent(Dock *parent) { this->parent_ = parent; }
 
         protected:
-            Dock *parent;
-            std::set<PlayerInfo*> animations; //!< Contains a list of currently running animations
+            Dock *parent_;
+            std::set<PlayerInfo*> animations_; //!< Contains a list of currently running animations
     };
 
Index: /code/branches/presentation/src/modules/docking/DockingController.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingController.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingController.cc	(revision 8568)
@@ -42,4 +42,8 @@
     {
         RegisterObject(DockingController);
+
+        this->dock_ = NULL;
+        this->player_ = NULL;
+        this->entity_ = NULL;
     }
 
@@ -55,10 +59,10 @@
             return;
 
-        float distance = (dock->getWorldPosition() - entity->getPosition()).length();
+        float distance = (this->dock_->getWorldPosition() - entity->getPosition()).length();
         Vector2 coord = get2DViewdirection(     // I don't understand this too
             entity->getPosition(),
             entity->getOrientation() * WorldEntity::FRONT,
             entity->getOrientation() * WorldEntity::UP,
-            dock->getWorldPosition()
+            dock_->getWorldPosition()
         );
 
@@ -86,8 +90,8 @@
     void DockingController::takeControl(bool docking)
     {
-        this->docking = docking;
+        this->docking_ = docking;
 
-        entity = player->getControllableEntity();
-        assert(entity);
+        this->entity_ = this->player_->getControllableEntity();
+        assert(this->entity_);
 
         if (docking)
@@ -95,8 +99,8 @@
             COUT(4) << "DockingController::takeControl Taking over control." << std::endl;
 
-            entity->setDestroyWhenPlayerLeft(false);
-            player->pauseControl();
-            entity->setController(this);
-            this->setControllableEntity(entity);
+            this->entity_->setDestroyWhenPlayerLeft(false);
+            this->player_->pauseControl();
+            this->entity_->setController(this);
+            this->setControllableEntity(this->entity_);
         }
     }
@@ -106,19 +110,19 @@
         COUT(4) << "DockingController::positionReached() called." << std::endl;
 
-        assert(this->player);
-        assert(this->dock);
+        assert(this->player_);
+        assert(this->dock_);
 
         // stop spaceship
-        entity->setPosition(dock->getWorldPosition());
-        entity->setVelocity(0, 0, 0);
-        entity->setOrientation(dock->getWorldOrientation());
+        this->entity_->setPosition(this->dock_->getWorldPosition());
+        this->entity_->setVelocity(0, 0, 0);
+        this->entity_->setOrientation(this->dock_->getWorldOrientation());
 
         // give control back to player
-        player->startControl(entity);
+        this->player_->startControl(this->entity_);
         this->setActive(false);
         this->controllableEntity_ = NULL;
 
-        if (docking)
-            dock->dockingAnimationFinished(player);
+        if (this->docking_)
+            this->dock_->dockingAnimationFinished(this->player_);
         /*else
             dock->undockingAnimationFinished(player);*/
Index: /code/branches/presentation/src/modules/docking/DockingController.h
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingController.h	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingController.h	(revision 8568)
@@ -49,6 +49,6 @@
             void takeControl(bool docking);
 
-            void setDock(Dock* dock) { this->dock = dock; }
-            void setPlayer(PlayerInfo* player) { this->player = player; }
+            void setDock(Dock* dock) { this->dock_ = dock; }
+            void setPlayer(PlayerInfo* player) { this->player_ = player; }
 
         protected:
@@ -56,10 +56,10 @@
 
         private:
-            bool docking;
+            bool docking_;
 
-            Dock* dock;
-            PlayerInfo* player;
+            Dock* dock_;
+            PlayerInfo* player_;
 
-            ControllableEntity* entity;
+            ControllableEntity* entity_;
     };
 }
Index: /code/branches/presentation/src/modules/docking/DockingEffect.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingEffect.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingEffect.cc	(revision 8568)
@@ -62,6 +62,5 @@
 
     DockingTarget *DockingEffect::findTarget(std::string name) {
-        for (ObjectList<DockingTarget>::iterator it = ObjectList<DockingTarget>::begin();
-                                 it != ObjectList<DockingTarget>::end(); ++it)
+        for (ObjectList<DockingTarget>::iterator it = ObjectList<DockingTarget>::begin(); it != ObjectList<DockingTarget>::end(); ++it)
         {
             if ((*it)->getName().compare(name) == 0)
Index: /code/branches/presentation/src/modules/docking/DockingTarget.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingTarget.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingTarget.cc	(revision 8568)
@@ -60,9 +60,9 @@
 
     void DockingTarget::setName(const std::string& str) {
-        this->name = str;
+        this->name_ = str;
     }
 
     const std::string& DockingTarget::getName() const {
-        return this->name;
+        return this->name_;
     }
 }
Index: /code/branches/presentation/src/modules/docking/DockingTarget.h
===================================================================
--- /code/branches/presentation/src/modules/docking/DockingTarget.h	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/DockingTarget.h	(revision 8568)
@@ -55,5 +55,5 @@
     {
         private:
-            std::string name;
+            std::string name_;
 
         public:
Index: /code/branches/presentation/src/modules/docking/MoveToDockingTarget.cc
===================================================================
--- /code/branches/presentation/src/modules/docking/MoveToDockingTarget.cc	(revision 8567)
+++ /code/branches/presentation/src/modules/docking/MoveToDockingTarget.cc	(revision 8568)
@@ -52,8 +52,8 @@
     bool MoveToDockingTarget::docking(PlayerInfo *player)
     {
-        assert(parent);
+        assert(this->parent_);
 
         DockingController *dockingController = new DockingController(this);
-        dockingController->setDock(parent);
+        dockingController->setDock(this->parent_);
         dockingController->setPlayer(player);
         dockingController->takeControl(true);
@@ -65,7 +65,7 @@
     {
         //TODO: Investigate strange things...
-        parent->detach((WorldEntity*)player->getControllableEntity());
+        this->parent_->detach((WorldEntity*)player->getControllableEntity());
 
-        parent->undockingAnimationFinished(player);
+        this->parent_->undockingAnimationFinished(player);
         return true;
     }